SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'FredHsu 5/14/2012 11:29' prior: 0!
Class intention
	This class is for the LightsOut example

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!LOCell methodsFor: 'initialization' stamp: 'FredHsu 5/14/2012 11:36'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff 
	! !

!LOCell methodsFor: 'accessing' stamp: 'FredHsu 5/14/2012 12:05'!
mouseAction: aBlock
	^ mouseAction := aBlock
	! !

!LOCell methodsFor: 'accessing' stamp: 'FredHsu 5/14/2012 12:07'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'FredHsu 5/14/2012 11:56'!
cellsPerSide 
	"The number of cells along each side of the game"
	^10! !

!LOGame methodsFor: 'initialization' stamp: 'FredHsu 5/14/2012 11:46'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width * n)@(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'game logic' stamp: 'FredHsu 5/14/2012 12:16'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'FredHsu 5/14/2012 12:12'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen represntation at the appropriate screen position.  Answer the new cell"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c! !

!LOGame methodsFor: 'game logic' stamp: 'FredHsu 5/14/2012 12:03'!
toggleNeighboursOfCellAt: i at: j
	"comment stating purpose of message"
	(i > 1) ifTrue: [ (cells at: i - 1 at: j) toggleState].
	(i < self cellsPerSide ) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j-1) toggleState].
	(j < self cellsPerSide ) ifTrue: [(cells at: i at: j + 1) toggleState].! !
